/** \file   my_opcache.h
 *  \brief  A cache for binary operations
 *  \author Takahisa Toda
 */
#ifndef MY_OPCACHE_H
#define MY_OPCACHE_H

#define OPCACHE_DEFAULT_SIZE       (UINTMAX_C(1) << 24)

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/** \brief my opcache */
typedef struct {
  uintmax_t nent;   //!< the number of operation cache entries
  uintptr_t *entry; //!< the i-th entry has size OPCACHE_ENTRY_SIZE and start from the position i*OPCACHE_ENTRY_SIZE, where 0 <= i < num.
} my_opcache;

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/
extern my_opcache *opcache_create(uintmax_t opcache_size);
extern void opcache_destroy(my_opcache *ch);
extern void opcache_add(int op, uintptr_t k1, uintptr_t k2, uintptr_t r, my_opcache *ch);
extern int  opcache_search(int op, uintptr_t k1, uintptr_t k2, uintptr_t *pr, my_opcache *ch);
extern void opcache_enlarge(my_opcache *ch);

#endif /*MY_OPCACHE_H*/
